
cast8to16:
	bit 7,l
	ret z
	push de
	ld a,l
	neg
	ld l,a
	ld h,0
	ex de,hl
	ld hl,0
	or a
	sbc hl,de
	pop de
	ret

cast16to8:
	bit 7,h
	jr nz,cast16to8_1
	ld h,0
	ret
cast16to8_1:
	ld l,h
	ld h,0
	ret

keyloop:
	call $5371
	cp $37
	ret z
	jp keyloop

mult:	;unsigned 8 bit mult; returns b=a*e
	ld b,0
	ld c,0
mult1:
	sla b
	sla a
	jr nc,mult2
	ld d,a		;save a in d
	ld a,e
	add a,b
	ld b,a
	ld a,d		;restore a
mult2:
	inc c
	ld d,a
	ld a,8
	cp c
	ld a,d
	ret z
	jr mult1

mult16:	;16 bit mult; returns hl=bc*de
	ld a,16
	push af
	ld bc,0
mult16_1:
	sla c
	rl b
	sla l
	rl h
	jr nc,mult16_2
	push hl
	ld h,d
	ld l,e
	add hl,bc
	ld b,h
	ld c,l
	pop hl
mult16_2:
	pop af
	dec a
	or a
	jr nz,mult16_3
	ld h,b
	ld l,c
	ret
mult16_3:
	push af
	jr mult16_1

div:	;unsigned 8 bit div; returns c=a/e, a=a%e
	ld c,a
	ld b,8
	xor a
div1:
	or a
	rl c            
	rla             
	cp e
	jr c,div2
	sub e
	inc c
div2:
	djnz div1       
	ret

divs:	;signed 8 bit div; returns c=a/e, a=a%e
	push af
	xor e
	ld d,a
	bit 7,e
	jr z,divs4
	ld a,e
	neg
	ld e,a
divs4:
	pop af
	bit 7,a
	jr z,divs3
	neg
divs3:
	ld c,a
	ld b,8
	xor a
divs1:
	or a
	rl c
	rla
	cp e
	jr c,divs2
	sub e
	inc c
divs2:
	djnz divs1
	push af
	bit 7,d
	jr z,divs5
	ld a,c
	neg
	ld c,a
divs5:
	pop af
	ret

div16:	;16 bit div; returns hl=hl/de, bc=hl%de
	ld a,17
	ld bc,0
	or a
div16_1:
	rl l
	rl h
	rl c
	rl b
	push hl
	ld h,b
	ld l,c
	sbc hl,de
	jr nc,div16_2
	pop hl
	dec a
	or a
	ret z
	jr div16_1
div16_2:
	ld b,h
	ld c,l
	pop hl
	dec a
	or a
	jr nz,div16_3
	bit 0,l
	jr z,div16_4
	or a
	rr b
	rr c
	ret
div16_4:
	or a
	rl c
	rl b
	ret
div16_3:
	scf
	jr div16_1

divs16:	;16 bit signed div; returns hl=hl/de, bc=hl%de
	ld a,h
	xor d
	push af
	bit 7,h
	jr z,divs16_4
	ld b,h
	ld c,l
	ld hl,0
	or a
	sbc hl,bc
divs16_4:
	bit 7,d
	jr z,divs16_5
	push hl
	ld hl,0
	sbc hl,de
	ld d,h
	ld e,l
	pop hl
divs16_5:
	ld a,17
	ld bc,0
	or a
divs16_1:
	rl l
	rl h
	rl c
	rl b
	push hl
	ld h,b
	ld l,c
	sbc hl,de
	jr nc,divs16_2
	pop hl
	dec a
	or a
	jr z,divs16_3
	jr divs16_1
divs16_2:
	ld b,h
	ld c,l
	pop hl
	dec a
	or a
	jr z,divs16_3
	scf
	jr divs16_1
divs16_3:
	pop af
	bit 7,a
	jr z,divs16_6
	ex de,hl
	ld hl,0
	or a
	sbc hl,de
divs16_6:
	bit 0,l
	jr z,divs16_7
	or a
	rr b
	rr c
	ret
divs16_7:
	or a
	rl c
	rl b
	ret

lshift16:
	ld b,e
	ld a,0
	cp b
	ret z
lshift16_1:
	sla l
	rl h
	djnz lshift16_1
	ret

lshift:
	ld b,e
lshift1:
	sla a
	djnz lshift1
	ld l,a
	ld h,0
	ret

rshift16:
	ld b,e
rshift16_1:
	sla h
	rr l
	djnz rshift16_1
	ret

rshift:
	ld b,e
rshift1:
	sra a
	djnz rshift1
	ld l,a
	ld h,0
	ret

and16:
	ld a,l
	and e
	ld c,a
	ld a,h
	and d
	ld b,d
	ret

xor16:
	ld a,l
	xor e
	ld c,a
	ld a,h
	xor d
	ld b,d
	ret

or16:
	ld a,l
	or e
	ld c,a
	ld a,h
	or d
	ld b,d
	ret

cpl16:
	cpl
	ld l,a
	ld a,d
	cpl
	ld h,a
	ret

lt16:
	ld bc,0
	ld a,h
	cp d
	jr z,lt16_3
	jr nc,lt16_1
	jp lt16_2
lt16_3:
	ld a,l
	cp e
	jr z,lt16_1
	jr nc,lt16_1
lt16_2:
	ld c,1
lt16_1:
	ret

lts16:
	ld bc,0
	bit 7,h
	jr z,lts16_4
	bit 7,d
	jr nz,lts16_5
	ld c,1
	ret
lts16_4:
	bit 7,d
	jr z,lts16_5
	ret
lts16_5:
	ld a,h
	cp d
	jr z,lts16_3
	jr nc,lts16_1
	jp lts16_2
lts16_3:
	ld a,l
	cp e
	jr z,lts16_1
	jr nc,lts16_1
lts16_2:
	ld c,1
lts16_1:
	ret

lt:
	cp e
	ld hl,0
	jr z,lt1
	jr nc,lt1
	ld l,1
lt1:
	ret

lts:
	ld hl,0
	bit 7,a
	jr z,lts2
	bit 7,e
	jr nz,lts3
	ld l,1
	ret
lts2:
	bit 7,e
	jr z,lts3
	ret
lts3:
	cp e
	jr z,lts1
	jr nc,lts1
	ld l,1
lts1:
	ret

gt16:
	ld bc,0
	ld a,h
	cp d
	jr z,gt16_3
	jr c,gt16_1
	jp gt16_2
gt16_3:
	ld a,l
	cp e
	jr z,gt16_1
	jr c,gt16_1
gt16_2:
	ld c,1
gt16_1:
	ret

gts16:
	ld bc,0
	bit 7,h
	jr z,gts16_4
	bit 7,d
	jr nz,gts16_5
	ret
gts16_4:
	bit 7,d
	jr z,gts16_5
	ld c,1
	ret
gts16_5:
	ld a,h
	cp d
	jr z,gts16_3
	jr c,gts16_1
	jp gts16_2
gts16_3:
	ld a,l
	cp e
	jr z,gts16_1
	jr c,gts16_1
gts16_2:
	ld c,1
gts16_1:
	ret

gt:
	ld hl,0
	cp e
	jr z,gt1
	jr c,gt1
	ld l,1
gt1:
	ret

gts:
	ld hl,0
	bit 7,a
	jr z,gts2
	bit 7,e
	jr nz,gts3
	ret
gts2:
	bit 7,e
	jr z,gts3
	ld l,1
	ret
gts3:
	cp e
	jr z,gts1
	jr c,gts1
	ld l,1
gts1:
	ret

lte16:
	ld bc,0
	ld a,h
	cp d
	jr z,lte16_3
	jr nc,lte16_1
	jp lte16_2
lte16_3:
	ld a,l
	cp e
	jr z,lte16_2
	jr nc,lte16_1
lte16_2:
	ld c,1
lte16_1:
	ret

ltes16:
	ld bc,0
	bit 7,h
	jr z,ltes16_4
	bit 7,d
	jr nz,ltes16_5
	ld c,1
	ret
ltes16_4:
	bit 7,d
	jr z,ltes16_5
	ret
ltes16_5:
	ld a,h
	cp d
	jr z,ltes16_3
	jr nc,ltes16_1
	jp ltes16_2
ltes16_3:
	ld a,l
	cp e
	jr z,ltes16_2
	jr nc,ltes16_1
ltes16_2:
	ld c,1
ltes16_1:
	ret

lte:
	cp e
	ld hl,0
	jr z,lte2
	jr nc,lte1
lte2:
	ld l,1
lte1:
	ret

ltes:
	ld hl,0
	bit 7,a
	jr z,ltes2
	bit 7,e
	jr nz,ltes3
	ld l,1
	ret
ltes2:
	bit 7,e
	jr z,ltes3
	ret
ltes3:
	cp e
	jr z,ltes4
	jr nc,ltes1
ltes4:
	ld l,1
ltes1:
	ret

gte16:
	ld bc,0
	ld a,h
	cp d
	jr z,gte16_3
	jr c,gte16_1
	jp gte16_2
gte16_3:
	ld a,l
	cp e
	jr z,gte16_2
	jr c,gte16_1
gte16_2:
	ld c,1
gte16_1:
	ret

gtes16:
	ld bc,0
	bit 7,h
	jr z,gtes16_4
	bit 7,d
	jr nz,gtes16_5
	ret
gtes16_4:
	bit 7,d
	jr z,gtes16_5
	ld c,1
	ret
gtes16_5:
	ld a,h
	cp d
	jr z,gtes16_3
	jr c,gtes16_1
	jp gtes16_2
gtes16_3:
	ld a,l
	cp e
	jr z,gtes16_2
	jr c,gtes16_1
gtes16_2:
	ld c,1
gtes16_1:
	ret

gte:
	cp e
	ld hl,0
	jr z,gte2
	jr c,gte1
gte2:	
	ld l,1
gte1:
	ret

gtes:
	ld hl,0
	bit 7,a
	jr z,gtes2
	bit 7,e
	jr nz,gtes3
	ret
gtes2:
	bit 7,e
	jr z,gtes3
	ld l,1
	ret
gtes3:
	cp e
	jr z,gtes4
	jr c,gtes1
gtes4:
	ld l,1
gtes1:
	ret

eq16:
	ld bc,0
	ld a,l
	cp e
	jr nz,eq16_1
	ld a,h
	cp d
	jr nz,eq16_1
	ld c,1
eq16_1:
	ret

eq:
	cp e
	ld hl,0
	jr nz,eq1
	ld l,1
eq1:
	ret

neq16:
	ld bc,1
	ld a,l
	cp e
	jr nz,neq16_1
	ld a,h
	cp d
	jr nz,neq16_1
	ld c,0
neq16_1:
	ret

neq:
	cp e
	ld hl,0
	jr z,neq1
	ld l,1
neq1:
	ret

band16:
	ld bc,0
	ld a,h
	or a
	jr nz,band16_1
	ld a,l
	or a
	jr nz,band16_1
	jp band16_2
band16_1:
	ld a,d
	or a
	jr nz,band16_3
	ld a,e
	or a
	jr nz,band16_3
	jp band16_2
band16_3:
	ld c,1
band16_2:
	ret

band:
	ld hl,0
	or a
	jr z,band1
	ld a,e
	or a
	jr z,band1
	ld l,1
band1:
	ret


bor16:
	ld bc,0
	ld a,h
	or a
	jr nz,bor16_1
	ld a,l
	or a
	jr nz,bor16_1
	ld a,d
	or a
	jr nz,bor16_1
	ld a,e
	or a
	jr nz,bor16_1
	jp bor16_2
bor16_1:
	ld c,1
bor16_2:
	ret

bor:
	ld hl,0
	or a
	jr nz,bor2
	ld a,e
	or a
	jr z,bor1
bor2:
	ld l,1
bor1:
	ret

not16:
	ld b,0
	ld a,h
	or a
	jr nz,not16_1
	ld a,l
	or a
	jr nz,not16_1
	ld l,1
	jp not16_2
not16_1:
	ld l,0
not16_2:
	ret

not:
	ld h,0
	or a
	jr nz,not1
	ld l,1
	jp not2
not1:
	ld l,0
not2:
	ret

ptrup:
	ld a,(hl)
	ld e,a
	ld bc,1
	add hl,bc
	ld a,(hl)
	ld h,a
	ld l,e
	ret

_offsets:
.db 128,64,32,16,8,4,2,1

